diff --git a/lib/connect.c b/lib/connect.c
index 197eff242fb0..30611d8fdb42 100644
--- a/lib/connect.c
+++ b/lib/connect.c
@@ -1075,17 +1075,25 @@ static CURLcode singleipconnect(struct connectdata *conn,
   /* Connect TCP sockets, bind UDP */
   if(!isconnected && (conn->socktype == SOCK_STREAM)) {
     if(conn->bits.tcp_fastopen) {
-#if defined(CONNECT_DATA_IDEMPOTENT) /* OS X */
-      sa_endpoints_t endpoints;
-      endpoints.sae_srcif = 0;
-      endpoints.sae_srcaddr = NULL;
-      endpoints.sae_srcaddrlen = 0;
-      endpoints.sae_dstaddr = &addr.sa_addr;
-      endpoints.sae_dstaddrlen = addr.addrlen;
-
-      rc = connectx(sockfd, &endpoints, SAE_ASSOCID_ANY,
-                    CONNECT_RESUME_ON_READ_WRITE | CONNECT_DATA_IDEMPOTENT,
-                    NULL, 0, NULL, NULL);
+#if defined(CONNECT_DATA_IDEMPOTENT) /* Darwin */
+#  pragma GCC diagnostic push
+#  pragma GCC diagnostic ignored "-Wpartial-availability"
+        if(connectx != NULL) {
+          sa_endpoints_t endpoints;
+          endpoints.sae_srcif = 0;
+          endpoints.sae_srcaddr = NULL;
+          endpoints.sae_srcaddrlen = 0;
+          endpoints.sae_dstaddr = &addr.sa_addr;
+          endpoints.sae_dstaddrlen = addr.addrlen;
+
+          rc = connectx(sockfd, &endpoints, SAE_ASSOCID_ANY,
+                        CONNECT_RESUME_ON_READ_WRITE | CONNECT_DATA_IDEMPOTENT,
+                        NULL, 0, NULL, NULL);
+        }
+        else {
+          return CURLE_NOT_BUILT_IN;
+        }
+#  pragma GCC diagnostic pop
 #elif defined(MSG_FASTOPEN) /* Linux */
       if(conn->given->flags & PROTOPT_SSL)
         rc = connect(sockfd, &addr.sa_addr, addr.addrlen);
diff --git a/lib/curl_setup.h b/lib/curl_setup.h
index 0fe3633ec760..14142a779055 100644
--- a/lib/curl_setup.h
+++ b/lib/curl_setup.h
@@ -762,4 +762,18 @@ endings either CRLF or LF so 't' is appropriate.
 #  endif
 # endif
 
+/* Detect Darwin connectx() function availability.
+ * The connectx() function call appeared in Darwin 15.0.0
+ * but it's not declared using availability attribute.
+ */
+
+#if defined(CONNECT_DATA_IDEMPOTENT)
+/* multiple function declarations with attributes is allowed in GNU extension */
+extern int connectx(int socket, const sa_endpoints_t *endpoints,
+                    sae_associd_t associd, unsigned int flags,
+                    const struct iovec *iov, unsigned int iovcnt,
+                    size_t *len, sae_connid_t *connid)
+                    __OSX_AVAILABLE_STARTING(__MAC_10_11, __IPHONE_9_0);
+#endif
+
 #endif /* HEADER_CURL_SETUP_H */
diff --git a/lib/url.c b/lib/url.c
index 03feaa20f7f7..530052fbdead 100644
--- a/lib/url.c
+++ b/lib/url.c
@@ -2834,12 +2834,22 @@ CURLcode Curl_setopt(struct Curl_easy *data, CURLoption option,
     data->set.tcp_keepintvl = va_arg(param, long);
     break;
   case CURLOPT_TCP_FASTOPEN:
-#if defined(CONNECT_DATA_IDEMPOTENT) || defined(MSG_FASTOPEN)
-    data->set.tcp_fastopen = (0 != va_arg(param, long))?TRUE:FALSE;
-#else
-    result = CURLE_NOT_BUILT_IN;
+  {
+    bool supports_fastopen = false;
+#if defined(CONNECT_DATA_IDEMPOTENT)
+#  pragma GCC diagnostic push
+#  pragma GCC diagnostic ignored "-Wpartial-availability"
+    supports_fastopen = (connectx != NULL);
+#  pragma GCC diagnostic pop
+#elif defined(MSG_FASTOPEN)
+    supports_fastopen = true;
 #endif
+    if(supports_fastopen)
+      data->set.tcp_fastopen = (0 != va_arg(param, long)) ? TRUE : FALSE;
+    else
+      result = CURLE_NOT_BUILT_IN;
     break;
+  }
   case CURLOPT_SSL_ENABLE_NPN:
     data->set.ssl_enable_npn = (0 != va_arg(param, long)) ? TRUE : FALSE;
     break;
